using System;
using System.Text.RegularExpressions;
using System.Collections;
using System.Text;
using System.Web;

namespace Mail
{
	/// <summary>
	/// ,   .
	/// </summary>
	public class Utils
	{
		//  .
		static Hashtable knownEncodings = new Hashtable();

		static Utils()
		{

		}
		/// <summary>
		///      HTML .
		/// </summary>
		/// <param name="html">HTML .</param>
		/// <returns> .</returns>
		public static string ExtractTextFromHtml(string html)
		{
			//       
			// HTML .
			//   <!DOCTYPE ... >
			Regex r = new Regex(@"<![^>]+>"); //   .
			html = r.Replace(html, ""); //       .

			//  <head>...</head>
			r = new Regex(@"<head>.*?</head>", RegexOptions.IgnoreCase); //   .
			// r = new Regex(@"<style[^>]+[>].*?</style>", RegexOptions.IgnoreCase);
			html = r.Replace(html, ""); //       .
			//   </div>, <br />, </p>   
			r = new Regex(@"(</div>|<[/]?br[^>]+>|</p>)", RegexOptions.IgnoreCase); //   .
			html = r.Replace(html, "\r\n"); //          .

			//    <...>
			r = new Regex(@"<[^>]+>", RegexOptions.Multiline); //   ,    .
			html = r.Replace(html, ""); 
            html = HttpUtility.HtmlDecode(html);
			return html;
		}

		/// <summary>
		///    .
		/// </summary>
		/// <param name="charset">,   .</param>
		/// <returns></returns>
		public static Encoding GetEncoding(string charset)
		{
			// ,       ,
			//   ,  .
			if (knownEncodings.ContainsKey(charset)) 
			{
				return (Encoding)knownEncodings[charset];
			}
			//    ,    .
			Encoding e = Encoding.Default;
			try
			{
				e = Encoding.GetEncoding(charset);
			}
			catch {}

			//     .
			knownEncodings.Add(charset, e);
			//  .
			return e;
		}


		/// <summary>
		///  "byte-stuffed",  RFC1939 
		/// \r\n.[not \r\n] => \r\n[not \r\n]
		/// </summary>
		/// <param name="s"></param>
		/// <returns></returns>
		public static string RemoveByteStuffedSequence(string s)
		{
			Regex r = new Regex(@"(?<=\r\n)\.(?!\r\n)");
			return r.Replace(s, "");
		}

		/// <summary>
        ///  
		/// </summary>
		/// <param name="s"></param>
		/// <returns></returns>
		static public string DecodeQuotedPrintable(string s, Encoding e)
		{
			_curEncoding = e;
			Regex re = new Regex(@"=([a-fA-F0-9]{2})");
			return re.Replace(s, new MatchEvaluator(ReDigit));
		}


		static Encoding _curEncoding;
		/// <summary>
        ///  ""   
		/// </summary>
		/// <param name="match">"XX" </param>
		/// <returns></returns>
		static string ReDigit(Match match)
		{
			byte [] tmp = {Convert.ToByte(match.Groups[1].Value, 16)};
			return "" + _curEncoding.GetString(tmp);
		}

		/// <summary>
		/// RFC 2047
		/// </summary>
		/// <param name="s"></param>
		/// <returns></returns>
		static public string WordDecoder(string input)
		{
			string charset = "";
			string src;
			string tmp;
			src = input;
			Match m = Regex.Match(input, @"(?<ew>(?<n>\=\?(?<charset>[^?]+)\?(?<encoding>[QqBb])\?(?<content>[^?]+)\?\=)(\r\n)*\s*)(?=(?<isnext>\=\?[^?]+\?[QqBb]\?[^?]+\?\=)*)", RegexOptions.Multiline);
			if (m.Success)
			{
				while (m.Success)
				{
					charset = m.Groups["charset"].Value;
					string encoding = m.Groups["encoding"].Value.ToLower();
					switch(encoding)
					{
						case "q":
							tmp = m.Groups["content"].Value.Replace("_", " ");
							tmp = DecodeQuotedPrintable(tmp, GetEncoding(m.Groups["charset"].Value));
							break;

						case "b":
							tmp = GetEncoding(charset).GetString(Convert.FromBase64String(m.Groups["content"].Value));
							break;

						default:
							throw new ParseException("  ");
					}

					src = src.Replace(((m.Groups["isnext"].Value.Length == 0) ? m.Groups["n"].Value : m.Groups["ew"].Value), tmp);
					m = m.NextMatch();
				}

				return src; 
			}

			return GetEncoding(charset).GetString(Encoding.Default.GetBytes(src));
		}
	}
}
