using System;
using System.Security.Principal;
using System.Xml.Serialization;
using System.IO;

namespace MailApplication
{
	/// <summary>
	///  .
	/// </summary>
	public class UserIdentity: IIdentity, IDisposable
	{
		string _alias;
		string _name;
		string _mail;
		string _password;
		string _pop3;
		int    _pop3port;
		string _smtp;

		public UserIdentity(string userName)
		{
			XmlSerializer ser = new XmlSerializer(typeof(UserIdentity));
			FileStream str = new FileStream(userName, FileMode.Open);
			UserIdentity identity = (UserIdentity)ser.Deserialize(str);
			str.Close();
			this._alias = identity._alias;
			this._mail = identity._mail;
			this._name = identity._name;
			this._password = identity._password;
			this._pop3 = identity._pop3;
			this._pop3port = identity._pop3port;
			this._smtp = identity._smtp;
		}


		public UserIdentity()
		{
			this._alias = String.Empty;
			this._mail = String.Empty;
			this._name = String.Empty;
			this._password = String.Empty;
			this._pop3 = String.Empty;
			this._pop3port = -1;
			this._smtp = String.Empty;
		}
		#region IIdentity Members

		public bool IsAuthenticated
		{
			get
			{
				throw new System.Security.SecurityException("  ");
			}
		}
		/// <summary>
		///  .
		/// </summary>
		public string Name
		{
			get
			{				
				return this._name;
			}
			set{this._name = value;}
		}

		public string AuthenticationType
		{
			get
			{
				throw new System.Security.SecurityException("  ");
			}
		}

		#endregion

		/// <summary>
		///   .
		/// </summary>
		public string Mail
		{
			get{return this._mail;}
			set
			{
				this._mail = value;
				this._name = this.Mail.Substring(0, this.Mail.Length - this.Mail.IndexOf("@"));
			}
		}
		/// <summary>
		///  .
		/// </summary>
		public string Password
		{
			get{return this._password;}
			set{this._password = value;}
		}
		/// <summary>
		/// Pop3 .
		/// </summary>
		public string Pop3
		{
			get{return this._pop3;}
			set{this._pop3 = value;}
		}
		/// <summary>
		/// Smtp .
		/// </summary>
		public string Smtp
		{
			get{return this._smtp;}
			set{this._smtp = value;}
		}
		/// <summary>
		///  Pop3 .
		/// </summary>
		public int Pop3Port
		{
			get{return this._pop3port;}
			set{this._pop3port = value;}
		}
		/// <summary>
		///  .
		/// </summary>
		public string Alias
		{
			get{return this._alias;}
			set{this._alias = value;}
		}

		/// <summary>
		///    .
		/// </summary>
		private void Save()
		{
			XmlSerializer ser = new XmlSerializer(typeof(UserIdentity));
			FileStream str = new FileStream(this.Name + ".usr", FileMode.Create);
			ser.Serialize(str, this);
			str.Close();
		}

		#region IDisposable Members

		public void Dispose()
		{
			if(this.ValidateData())
				this.Save();
		}
		/// <summary>
		///   .
		/// </summary>
		/// <returns></returns>
		bool ValidateData()
		{			
			this._password = "";
			if(this._mail == "")
				return false;
			if(this._name == "")
				return false;
			if(this._pop3 == "")
				return false;
			if(this._smtp == "")
				return false;
			return true;
		}
		#endregion
	}
}
